<div class="jgrapes-osgi-bundles-view"
  data-jgwc-on-load="orgJGrapesOsgiConletBundles.initView"
  data-jgwc-on-unload="JGConsole.jgwc.unmountVueApps"> 
  <div class="jgrapes-osgi-bundles-view-search">
    <form>
      <label class="form__label--horizontal">
        <span>{{ localize("Filter") }}</span>
        <input type="search" v-on:input="controller.updateFilter($event)">
        <span role="button" tabindex="0" class="fas fa-backspace" 
          v-on:click="controller.clearFilter($event)"></span>
      </label>
    </form>
  </div>
  <table 
    class="table--basic--striped jgrapes-osgi-bundles-view-table">
    <thead>
      <tr>
        <th v-for="key in controller.keys"
          class="sortable" v-on:click="controller.sortBy(key)">
          {{ localize(controller.label(key)) }}<span v-if="controller.sortedByAsc(key)"
            role="button" tabindex="0">&#x25B2;</span><span
            v-if="controller.sortedByDesc(key)" role="button" 
            tabindex="0">&#x25BC;</span>
        </th>
        <th>
          {{ localize("bundleActions") }}
        </th>
      </tr>
    </thead>
    <tbody>
      <template v-for="(entry, rowIndex) in filteredData">
        <tr :class="[(rowIndex % 2) ? 'odd' : 'even']"
          :aria-expanded="(entry.id in detailsById) ? 'true' : 'false'">
          <td v-for="key in controller.keys" 
            v-bind:title="key == 'name' ? entry['symbolicName']: false"
            v-bind:rowspan="(key == 'id') && $aash.isDisclosed(scopedId(rowIndex)) ? 2 : false">
            <aash-disclosure-button v-if="key === 'id'" :type="'div'"
              :id-ref="scopedId(rowIndex)"
              :on-toggle="function(show) { updateDetails(entry.id, show); }">
              <span v-html="controller.breakBeforeDots(entry[key])"></span>
            </aash-disclosure-button>
            <span v-else-if="key === 'state'"
              v-html="localize(entry[key])"></span>
            <span v-else
	          v-html="controller.breakBeforeDots(entry[key])"></span>
          </td>
          <td class="jgrapes-osgi-bundles-view-action-list">
            <span role="button" v-if="entry.startable" 
              tabindex="0" class="fas fa-play" :title="localize('bundleStart')"
              v-on:click="bundleAction(entry.id, 'start')"></span>
            <span role="button" v-if="entry.stoppable"
              tabindex="0" class="fas fa-stop" :title="localize('bundleStop')"
              v-on:click="bundleAction(entry.id, 'stop')"></span>
            <span role="button" class="fas fa-sync" tabindex="0"
              :title="localize('bundleUpdate')"
              v-on:click="bundleAction(entry.id, 'update')"></span>
            <span role="button" class="fas fa-eject" tabindex="0"
              :title="localize('bundleUninstall')"
              v-bind:disabled="!entry.uninstallable"
              v-on:click="bundleAction(entry.id, 'uninstall')"></span>
          </td>
        </tr>
        <tr :id="scopedId(rowIndex)" v-if="$aash.isDisclosed(scopedId(rowIndex))"
          :class="[(rowIndex % 2) ? 'odd' : 'even']">
          <td colspan="5" class="details">
            <table class="table--basic table--basic--autoStriped">
              <tr>
                <td>{{ localize(controller.label('name')) }}</td>
                <td><span v-html="controller.breakBeforeDots(entry['name'])"></span></td>
              </tr>
              <tr v-for="detail in detailsById.get(entry.id)">
                <td>{{ localize(detail[0]) }}</td>
                <td v-if="detail[2] == 'table'">
                  <table class="table--basic table--basic--autoStriped">
                    <tr v-for="row in detail[1]">
                      <td v-html="controller.breakBeforeDots(row[0])"></td>
                      <td v-if="/.*-Package/i.test(row[0])
                        || /.*-Capability/i.test(row[0])"
                        v-html="addManifestValueBreaks(row[1])"></td>
                      <td v-else
                        v-html="controller.breakBeforeDots(row[1])"></td>
                    </tr>
                  </table>
                </td>
                <td v-else-if="detail[2] == 'dateTime'"><span v-html="formatDateTime(detail[1])"></span></td>
                <td v-else><span v-html="detail[1]"></span></td>
              </tr>
            </table>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
</div>
